<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- 
  compute the binary representation of any number
  with n bits
  --> 

<xsl:template match="anargiros">
<html>

 <xsl:for-each select="number">
    The binary representation of <xsl:value-of select="."/> is:
     <xsl:call-template name="normalize">
           <xsl:with-param name="x" select="."/>
           <xsl:with-param name="p" select="0"/>
       </xsl:call-template>
     <br/>
 </xsl:for-each>

</html>
</xsl:template>

<!-- user-defined function: normalize -->

<xsl:template name="normalize">
    <xsl:param name="x"/>
    <xsl:param name="p"/>

    <xsl:choose>

      <xsl:when test="$x &gt; 1.0">
       <xsl:call-template name="normalize">
          <xsl:with-param name="x" select="0.5 * $x"/>
          <xsl:with-param name="p" select="$p + 1"/>
       </xsl:call-template>
      </xsl:when>

      <xsl:otherwise>
        <xsl:call-template name="reduce">
           <xsl:with-param name="x" select="2 *($x - floor($x))"/>
           <xsl:with-param name="n" select="16"/>
           <xsl:with-param name="p" select="$p"/>
       </xsl:call-template>
      </xsl:otherwise>

    </xsl:choose>

</xsl:template>

<!-- user-defined function:reduce -->

<xsl:template name="reduce">
  <xsl:param name="x"/>
  <xsl:param name="n"/>
  <xsl:param name="p"/>

  <xsl:if test="$p = 0">.</xsl:if>

  <xsl:if test="$n &gt; 0">
    <xsl:value-of select="floor($x)"/>
    <xsl:call-template name="reduce">
      <xsl:with-param name="x" select="2 * ($x - floor($x))"/>
      <xsl:with-param name="n" select="$n - 1"/>
      <xsl:with-param name="p" select="$p - 1"/>
    </xsl:call-template>
  </xsl:if>

</xsl:template>

<!-- end of user-defined functions -->

</xsl:stylesheet>
