<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- 
  compute the exponential of a number
  by Taylor series expansion
  keeping "nterms" terms
  --> 

<xsl:variable name="nterms" select="8"/>

<!-- root remplate -->

<xsl:template match="diogenes">
<html>

    <xsl:for-each select="number">
    e^<xsl:value-of select="."/> =
      <xsl:call-template name="nested">
        <xsl:with-param name="x" select="."/>
        <xsl:with-param name="e" select="1 + ( . div $nterms)"/>
        <xsl:with-param name="n" select="$nterms"/>
        <xsl:with-param name="p" select="floor(.)"/>
      </xsl:call-template>
    </xsl:for-each>

</html>
</xsl:template>

<!-- user defined function -->

<xsl:template name="nested">
  <xsl:param name="x"/>
  <xsl:param name="e"/>
  <xsl:param name="n"/>
  <xsl:param name="p"/>

  <xsl:choose>

   <xsl:when test="$n &gt; 1">
    <xsl:call-template name="nested">
      <xsl:with-param name="x" select="$x"/>
      <xsl:with-param name="e" select="1 + $x * $e div ($n - 1)"/>
      <xsl:with-param name="n" select="$n - 1"/>
      <xsl:with-param name="p" select="$p"/>
    </xsl:call-template>
   </xsl:when>

   <xsl:otherwise>
     <xsl:value-of select='format-number($e,"##.######")'/> 
<!--
     <xsl:value-of select='$e'/> 
-->
     (computed from the Taylor series with
     <xsl:value-of select="$nterms"/> terms)<br/>
     p= <xsl:value-of select="$p"/> <br/>
   </xsl:otherwise>

  </xsl:choose>

</xsl:template>

<!-- end of user defined function -->

</xsl:stylesheet>
