<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- 
  natural logarithm of a number
  by Taylor series expansion about 1
  keeping "nterms" (even) terms
  --> 

<xsl:variable name="nterms" select="32"/>

<!-- root remplate -->

<xsl:template match="themistokles">
<html>

    <xsl:for-each select="number">
    ln(<xsl:value-of select="."/>) =
      <xsl:call-template name="nested">
        <xsl:with-param name="t" select=". - 1"/>
        <xsl:with-param name="ln" select="1 - ($nterms - 1) div $nterms*(. -1 )"/>
        <xsl:with-param name="n" select="$nterms"/>
      </xsl:call-template>
    </xsl:for-each>

</html>
</xsl:template>

<!-- user defined function: nested -->

<xsl:template name="nested">
  <xsl:param name="t"/>
  <xsl:param name="ln"/>
  <xsl:param name="n"/>

  <xsl:choose>

   <xsl:when test="$n &gt; 2">
    <xsl:call-template name="nested">
      <xsl:with-param name="t" select="$t"/>
      <xsl:with-param name="ln" select="1 - $t*$ln*($n - 2) div ($n - 1)"/>
      <xsl:with-param name="n" select="$n - 1"/>
    </xsl:call-template>
   </xsl:when>

   <xsl:otherwise>
     <xsl:value-of select='format-number($t*$ln,"##.######")'/> 
<!--
     <xsl:value-of select="$t * $ln"/> 
-->
     (computed from the Taylor series with
     <xsl:value-of select="$nterms"/> terms)<br/>
   </xsl:otherwise>

  </xsl:choose>

</xsl:template>

<!-- end of user defined function -->

</xsl:stylesheet>
