<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- compute the square root of a number -->

<xsl:variable name="accuracy" select="0.00000001"/>

<xsl:template match="sqrt">
<html>

    <xsl:for-each select="number">
      <xsl:call-template name="update">
        <xsl:with-param name="radical" select="."/>
        <xsl:with-param name="root" select="number(.) div 2"/>
        <xsl:with-param name="iteration" select="5"/>
        <xsl:with-param name="error" select="1000.00"/>
      </xsl:call-template>
    </xsl:for-each>

</html>
</xsl:template>

<!-- user defined function -->

<xsl:template name="update">
  <xsl:param name="radical"/>
  <xsl:param name="root"/>
  <xsl:param name="iteration"/>
  <xsl:param name="error"/>

  <!-- -->
  <xsl:choose>
  <xsl:when test="$error &lt; -$accuracy or $error &gt; $accuracy">
  <!-- -->

  <xsl:choose>
  <xsl:when test="$iteration &gt; 0">
    <xsl:call-template name="update">
      <xsl:with-param name="radical" select="$radical"/>
      <xsl:with-param name="root" select="($root + $radical div $root) div 2"/>
      <xsl:with-param name="iteration" select="$iteration - 1"/>
      <xsl:with-param name="error" select="(-$root + $radical div $root) div 2"/>
    </xsl:call-template>
  </xsl:when>
  <xsl:otherwise>
    The square root of <xsl:value-of select="$radical"/>
    could not be computed in 5 iterations
    <br/>
  </xsl:otherwise>
  </xsl:choose>

  <!-- -->
  </xsl:when>
  <xsl:otherwise>
    The square root of <xsl:value-of select="$radical"/>
    is <xsl:value-of select="$root"/>
    accurate to the eighth decimal place
    <br/>
  </xsl:otherwise>
  </xsl:choose>
  <!-- -->

</xsl:template>

<!-- end of user defined function -->

</xsl:stylesheet>
